<?php

function zoptiload_get2env($get){
	$get = explode('&',$get);
	$env = array();
	foreach($get as $k=>$v){
		$v = explode('=',$v);
		if (count($v>1))
			$env[array_shift($v)]=implode('=',$v);
	}
	return $env;
}
function zoptiload_cache_static($scripts,$type='js'){
	$nom = "";
	if (count($scripts)){
		$nom = (defined('_DIR_VAR')?_DIR_VAR:_DIR_IMG) . $type. '_cache_' . md5(serialize($scripts)) . ".$type";
		if (
		  (isset($GLOBALS['var_mode']))
		  OR (!file_exists($nom))){
		  	$fichier = "";
		  	foreach($scripts as $script){
		  		if (!is_array($script)){
		  			lire_fichier($script,$contenu);
		  		}
		  		else {
		  			include_spip('public/assembler');
		  			$contenu = recuperer_fond($script[0],zoptiload_get2env($script[1]));
		  		}
				// passer les chemins en absolus sur les css
				if ($type=='css'){
					$path = dirname(url_absolue($script))."/"; // pour mettre sur les images
					// passer les url relatives a la css d'origine en url absolues
					$contenu = preg_replace(",url\s*\(\s*['\"]?([^'\"/][^:]*)['\"]?\s*\),Uims","url($path\\1)",$contenu);
				}
	  			$fichier .= $contenu . "\n";
		  	}
		  	// compacter uniquement les css par prudence
		  	if ($type=='css' AND function_exists('compacte'))
		  		$fichier = compacte($fichier,$type);
		  	// ecrire
		  	ecrire_fichier($nom,$fichier);
		  }
	}
	return $nom;
}

function zoptiload_insert_head($flux){
	$self = url_absolue(self(true));
	$path = $path = pathinfo($self);
	$dir = preg_quote($path['dirname'].'/',',');

	// rechercher les js, les agglomerer et les compacter, et mettre le tout dans un cache statique
	$scripts = array();
	preg_match_all(",<script\s[^>]*src=['\"]([^'\"]*)['\"][^>]*>\s*</script>,",$flux,$regs,PREG_SET_ORDER);
	foreach($regs as $script){
		$src = $script[1];
		if (preg_match(",(".$dir."|)spip.php[?](page=([^&]*).*)$,",$src,$r)){
			$src = array($r[3],str_replace('&amp;','&',$r[2]));
		}
		$scripts[$script[0]] = $src;
	}
	if ($src = zoptiload_cache_static($scripts,'js')){
		$scripts = array_keys($scripts);
		$flux = str_replace(reset($scripts),"<script type='text/javascript' src='$src'></script>",$flux);
		$flux = str_replace($scripts,"",$flux);
	}

	// rechercher les css, les agglomerer et les compacter, par type de media
	$css = array();
	preg_match_all(",<link\s[^>]*href=['\"]([^'\"]*)['\"][^>]*>,",$flux,$regs,PREG_SET_ORDER);
	foreach($regs as $style){
		if (preg_match(',rel=["\']stylesheet["\'],i',$style[0])
		&& preg_match(',media=["\']([^\'"]*)["\'],i',$style[0],$m)) {
			$src = $style[1];
			if (preg_match(",(".$dir."|)spip.php[?](page=([^&]*).*)$,",$src,$r)){
				$src = array($r[3],str_replace('&amp;','&',$r[2]));
			}
			$css[$m[1]][$style[0]] = $src;
		}
	}

	// et mettre le tout dans un cache statique
	// si plus d'une css ou si dynamique
	foreach($css as $m=>$s){
		if (count($s)>1 OR is_array(reset($s))){
			if ($src = zoptiload_cache_static($s,'css')){
				$s = array_keys($s);
				$flux = str_replace(reset($s),"<link rel='stylesheet' media='$m' href='$src' />",$flux);
				$flux = str_replace($s,"",$flux);
			}
		}
	}
	return $flux;
}

?>
